var set_cookie = "";
var parse_time = "PAGE_FINISHED";
var youku_ad_pattern = new RegExp("oip=2130706433");
var youku_pattern = new RegExp("src=\"(.*)\"");
var result = new Object();
var address = new Object();
var player = null;
var ad = false;
var timeOut = 15000;
var timeGap = 200;

function parse(ad_remove){
	/*window.JSBridge.test("youku parse: ad_remove:" + ad_remove);*/
	if(ad_remove == "true"){
		ad = true;
	}
	result.code = 'ok';
	result.msg = '';
	result.addresses = [];
	address.url = 'not start';
	setTimeout(simulateTouch, timeGap);
	/*window.JSBridge.test("youku parse set simulateTouch");*/
}

function pauseVideo(){
	player = document.getElementById("youku-html5player-video");
	if(player != null && player != undefined){
		player.pause();
	}
}

function resumeVideo(){
	player = document.getElementById("youku-html5player-video");
	if(player != null && player != undefined){
		player.play();
	}
}

function invoke_phone(){
	window.JSBridge.resultCallback(JSON.stringify(result));
}

function timer_callback(){
	if(timeOut <= 0){
		/*window.JSBridge.test("timer_callback timeout");*/
		result.code = 'error';
		result.msg = "parse timeout";
		invoke_phone();
		return;
	}
	timeOut = timeOut - timeGap;
    /*window.JSBridge.test("timer_callback start: ad:" + ad);*/
	player = document.getElementById("youku-html5player-video");
	if(player == null){
		setTimeout(simulateTouch, timeGap);
		return;
	}
	var parse = (player == null) ? null : player.currentSrc;
	if(parse == ''){
		setTimeout(simulateTouch, timeGap);
	}else if(parse == null || parse == address.url){
	    /*window.JSBridge.test("timer_callback parse same:" + parse);*/
		invoke_phone();
	}else{
		if(ad == false || !youku_ad_pattern.test(parse)){
		    /*window.JSBridge.test("timer_callback parse not ad:" + parse);*/
			address.url = parse;
			var obj = new Object();
			obj.url = parse.replace(/&amp;/g, '&');
			result.addresses.push(obj);
			/*youku only one url*/
			invoke_phone();
			return;
		}
		player.play();
		player.pause();
		var ev = document.createEvent('HTMLEvents');
		ev.initEvent('ended', false, true);
		player.dispatchEvent(ev);
		timeGap = 50;
		setTimeout(timer_callback, timeGap);
		/*window.JSBridge.test("timer_callback end");*/
	}
}

function TouchList() {
    var touchList = [];

    touchList.item = function(index) {
        return this[index] || null;
    };

    touchList.identifiedTouch = function(id) {
        return this[id + 1] || null;
    };

    return touchList;
}

function simulateTouch(){
	if(timeOut <= 0){
		/*window.JSBridge.test("reFindVideoTag timeout");*/
		result.code = 'error';
		result.msg = "parse timeout";
		invoke_phone();
		return;
	}
	timeOut = timeOut - timeGap;
    /*window.JSBridge.test("simulateTouch start");*/
	var playbtn = document.getElementById("x-video-button");
	if(playbtn == null){
		/*window.JSBridge.test("simulateTouch but play button null");*/
		setTimeout(simulateTouch, timeGap);
		return;
	}
	var touchList = new TouchList();
	touchList[0] = new Touch(playbtn);
	touchList.length = 1;
	var ev = document.createEvent('Event');
	ev.initEvent('touchend', true, true);
	ev.canBubble = false;
	ev.cancelable = true;
	ev.view = window;
	ev.detail = 0;
	ev.screenX = 0;
	ev.screenY = 0;
	ev.clientX = 0;
	ev.clientY = 0;
	ev.ctrlKey = false;
	ev.altKey = false;
	ev.shiftKey = false;
	ev.metaKey = false;
	ev.touches = touchList;
	ev.targetTouches = touchList;
	ev.changedTouches = touchList;
	ev.scale = 0;
	ev.rotation = 0;
	ev.touchItem = 0;
	playbtn.dispatchEvent(ev);
	/*window.JSBridge.test("simulateTouch end");*/
	player = document.getElementById("youku-html5player-video");
	if(player == null){
	    /*window.JSBridge.test("simulateTouch player null");*/
		setTimeout(reFindVideoTag, timeGap);
		return;
	}
	player.play();
	setTimeout(timer_callback, timeGap);
	/*window.JSBridge.test("simulateTouch end function");*/
}

function Touch(target){
	var touch = {
		clientX: 180,
		clientY: 180,
		force: 1,
		pageX: 180,
		pageY: 180,
		radiusX: 11.5,
		radiusY: 11.5,
		screenX: 278,
		screenY: 345,
		target: target,
		webkitForce: 1,
		webkitRadiusX: 11.5,
		webkitRadiusY: 11.5,
		webkitRotationAngle: 0
	};
	return touch;
}

function reFindVideoTag(){
	clearTimeout(reFindVideoTag);
    /*window.JSBridge.test("reFindVideoTag start");*/
	if(timeOut <= 0){
		/*window.JSBridge.test("reFindVideoTag timeout");*/
		result.code = 'error';
		result.msg = "parse timeout";
		invoke_phone();
		return;
	}
	timeOut = timeOut - timeGap;
	player = document.getElementById("youku-html5player-video");
	if(player == null){
	    /*window.JSBridge.test("reFindVideoTag player null");*/
		setTimeout(reFindVideoTag, timeGap);
	}else{
	    /*window.JSBridge.test("reFindVideoTag timer callback");*/
		setTimeout(timer_callback, timeGap);
	}
}